﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DebugExample
{
    #region HelperClass
    //This is just a helper class, I overload some operators here
    //I've not included any bugs in here because it contains some
    //weird stuff. But feel free to take a look.
    struct Point : IEquatable<Point>
    {
        public int x;
        public int y;
        public Point(int _x, int _y) { x = _x; y = _y; }

        public bool Equals(Point other)
        {
            return other.x == x && other.y == y;
        }

        public override bool Equals(object obj)
        {
            return Equals((Point)obj);
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

        public static bool operator ==(Point one, Point two)
        {
            return one.x == two.x && one.y == two.y;
        }
        public static bool operator !=(Point one, Point two)
        {
            return !(one.x == two.x && one.y == two.y);
        }
    }
    #endregion

    class Player
    {
        public enum Directions { Up, Down, Left, Right }
        public enum Stats { Strength, Defense, Speed, Luck }

        public Point position;
        public string appearence = "o/";
        public string name;
        public int health = 100;
        uint[] stats = new uint[4] { 0, 0, 0, 0 };

        public Player()
        {
            position = new Point(1, Game.MapSize.y - 1);
        }
        
        public string Battle(uint[] enemyStats)
        {
            //This script is a mess. It mostly juggles around values and randomness to try
            //to balance it so its not too hard or too easy.
            //Because this script is kind of a mess, I'm not putting any bugs in this function, but feel
            //free to take a look through the madness.
            string resultText = "Battle Result: ";
            int playerSpeed = (int)stats[(int)Stats.Speed];
            int enemySpeed = (int)enemyStats[(int)Stats.Speed];

            bool playerWin = stats[(int)Stats.Strength] == enemyStats[(int)Stats.Defense];
            if(playerWin == false)
            {
                if (enemyStats[(int)Stats.Strength] > stats[(int)Stats.Defense])
                    playerWin = false;
                else if (stats[(int)Stats.Strength] > enemyStats[(int)Stats.Defense])
                    playerWin = true;

                //If theres a luck or strength difference greater than 2, and the enemy is going to lose, the enemy has a chance to beat the player
                if(Math.Abs(stats[(int)Stats.Luck] - enemyStats[(int)Stats.Luck]) > 2 || Math.Abs(stats[(int)Stats.Strength] - enemyStats[(int)Stats.Strength]) > 2)
                {
                    if(playerWin)
                    {
                        playerWin = Game.RNG.Next(0, (int)stats[(int)Stats.Luck])+playerSpeed > Game.RNG.Next(0, (int)enemyStats[(int)Stats.Luck])+enemySpeed;
                    }
                }
            }
            else
            {
                playerWin = Game.RNG.Next(0, (int)stats[(int)Stats.Luck])+playerSpeed > Game.RNG.Next(0, (int)enemyStats[(int)Stats.Luck])+enemySpeed;
            }

            if(!playerWin)
            {
                int diff = (int)(enemyStats[(int)Stats.Strength] - stats[(int)Stats.Defense]);
                diff -= Game.RNG.Next(0, (int)stats[(int)Stats.Luck]+playerSpeed);
                if (diff < 0)
                    diff = 0;
                int damage = Game.RNG.Next(15, 25);
                damage = damage * diff;
                health -= damage;
                resultText = damage == 0 ? "You flawlessly murder your foe" : "You fight the enemy, and lose " + damage + " health!";
            }
            else
            {
                //If you're better than the enemy, you have a chance to suck his life from him
                int gain = Game.RNG.Next(0, (int)stats[(int)Stats.Luck]);
                health += gain;
                if (gain != 0)
                    resultText = "You crush the enemy so hard, you gain " + gain + " health";
                else
                    resultText = "You flawlessly murder your foe";
            }

            return resultText;
        }

        public Game.MapPieces Move(Directions direction)
        {
            //Quick note, in console Y values are reversed from what you would think.
            //So the down direction you would increase Y rather than lower it.
            Game.MapPieces piece = Game.MapPieces.Wall;
            switch (direction)
            {
                case Directions.Up:
                    piece = (Game.MapPieces)Game.map[position.y - 1, position.x];
                    if (piece == Game.MapPieces.Wall)
                        position.y--;
                    break;
                case Directions.Down:
                    piece = (Game.MapPieces)Game.map[position.y + 1, position.x];
                    if (piece != Game.MapPieces.Wall)
                        position.y++;
                    break;
                case Directions.Right:
                    piece = (Game.MapPieces)Game.map[position.y, position.x + 1];
                    if (piece != Game.MapPieces.Wall)
                        position.x++;
                    break;
                case Directions.Left:
                    piece = (Game.MapPieces)Game.map[position.y, position.x - 1];
                    if (piece != Game.MapPieces.Wall)
                        position.x--;
                    break;
            }

            return piece;
        }

        public uint GetStat(Stats stat)
        {
            return stats[(int)stat];
        }

        public bool AddStat(Stats stat, uint amount = 1)
        {
            int index = (int)stat;
            //Checks if the index is valid
            if (index > 0 && index < stats.Length)
            {
                stats[(int)stat] += amount;
                return true;
            }
            else
            {
                return false;
            }
        }

        public void SetStat(Stats stat, uint amount)
        {
            stats[(int)stat] = amount;
        }
    }
}
